<?php
function get_extension($str) 
{
	$i = strrpos($str,".");
	if (!$i) { return ""; }
	$l = strlen($str) - $i;
	$ext = substr($str,$i+1,$l);
	return $ext;
}
function validate_mage($file_name){
	$ext = get_extension($file_name);
	$allowed_extensions = array("jpg", "jpeg", "png","gif");
	if(in_array($ext,$allowed_extensions)){
		return true;
	}else{
		return false;
	}
}
function generate_token() {
	$alphabet = "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789";
	$pass = array(); //remember to declare $pass as an array
	$alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	for ($i = 0; $i < 40; $i++) {
		$n = rand(0, $alphaLength);
		$pass[] = $alphabet[$n];
	}
	return implode($pass); //turn the array into a string
}
function add_person($fn,$ln,$phone,$email,$date_of_birth,$profile,$gender,$picture,$reading,$dancing,$movies,$music){
	/* Connect to the database 
	   database username - > root
	   password -> empty
	   database name -> test
	*/
	$con = mysqli_connect("localhost","root","","test");
	/* Generate unique token for each person */
	$token = md5(time()).generate_token();
	/* Create the query string */
	$sql = "insert into persons(firstname,lastname,picture,phone,email,gender,date_of_birth,profile,reading,dancing,movies,music,token,date) values
	(
	'".$fn."',
	'".$ln."',
	'".$picture."',
	'".$phone."',
	'".$email."',
	'".$gender."',
	'".$date_of_birth."',
	'".$profile."',
	".$reading.",
	".$dancing.",
	".$movies.",
	".$music.",
	'".$token."',
	CURDATE()
	)
	";
	if(mysqli_query($con,$sql)){
		/* Close database connection */
		mysqli_close($con);
		return true;
	}else{
		mysqli_close($con);
		return false;
	}
}
$response = "";
$feedback = 0;
if(isset($_POST['fn'])){
    $fn = $_POST['fn'];
    $ln = $_POST['ln'];
    $phone = $_POST['phone'];
    $email = $_POST['email'];
    $day = $_POST['day'];
    $month = $_POST['month'];
    $year = $_POST['year'];
    $profile = $_POST['profile'];
    $gender = "";
	$picture = $_FILES['picture']['name'];
    if(isset($_POST['gender'])){
        $gender = $_POST['gender'];
    }
    $reading = 0;
    if(isset($_POST['reading'])){
	$reading=1; 
    }
    $dancing = 0;
    if(isset($_POST['dancing'])){
	$dancing=1; 
    }
    $music = 0;
    if(isset($_POST['music'])){
	$music=1; 
    }
    $movies = 0;
    if(isset($_POST['movies'])){
	$movies=1; 
    }
    if(empty($fn)){
		$response = "Please enter your first name";
    }else if(empty($ln)){
		$response = "Please enter last name";
    }else if(empty($phone)){
		$response = "Please enter phone number";
    }else if(empty($email)){
		$response = "Please enter email address";
    }else if(empty($gender)){
		$response = "Please select gender";
    }else if((empty($day))||(empty($month))||(empty($year))||(!checkdate($month,$day,$year))){
		$response = "Please check date of birth";
    }else if(empty($profile)){
		$response = "Please enter profile";
    }else if(empty($picture)){
		$response = "Please upload a picture";
	}else if(!validate_mage($picture)){
		$response = "Please only jpg, jpeg, png or gif files allowed";
	}else{
		/* Get the extension */
		$ext = get_extension($picture);
		/* Rename file */
		$image = generate_token().".".$ext;
		$path = "pictures/".$image;
		/* Note - We are saving the pictures in the pictures folder that's why you created that folder */
		/* Savel Image */
		if(copy($_FILES['picture']['tmp_name'], $path)){
			/* Since date is inserted in the year-month-day format, create the date_of_birth string */
			$date_of_birth = $year."-".$month."-".$day;
			/* Call the database function to insert the information. Check if insertion is successful to give successful feedback */
			if(add_person($fn,$ln,$phone,$email,$date_of_birth,$profile,$gender,$picture,$reading,$dancing,$movies,$music)){
				$response = "Information successfully recorded";
				$feedback = 1;
			}else{
				$response = "Failed adding person. Please try again later.";
			}
		}else{
			$response = "Image upload failed. Please try again later";
		}
    }
}
/* Send json information */
echo json_encode(array("feedback"=>$feedback,"response"=>$response));
?>