<?php
function get_extension($str) 
{
	$i = strrpos($str,".");
	if (!$i) { return ""; }
	$l = strlen($str) - $i;
	$ext = substr($str,$i+1,$l);
	return $ext;
}
function validate_mage($file_name){
	$ext = get_extension($file_name);
	$allowed_extensions = array("jpg", "jpeg", "png","gif");
	if(in_array($ext,$allowed_extensions)){
		return true;
	}else{
		return false;
	}
}
function generate_token() {
	$alphabet = "abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNOPQRSTUWXYZ0123456789";
	$pass = array(); //remember to declare $pass as an array
	$alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	for ($i = 0; $i < 40; $i++) {
		$n = rand(0, $alphaLength);
		$pass[] = $alphabet[$n];
	}
	return implode($pass); //turn the array into a string
}
function add_person($fn,$ln,$phone,$email,$date_of_birth,$profile,$gender,$picture,$reading,$dancing,$movies,$music){
	/* Connect to the database 
	   database username - > root
	   password -> empty
	   database name -> test
	*/
	$con = mysqli_connect("localhost","root","","test");
	/* Generate unique token for each person */
	$token = md5(time()).generate_token();
	/* Create the query string */
	$sql = "insert into persons(firstname,lastname,picture,phone,email,gender,date_of_birth,profile,reading,dancing,movies,music,token,date) values
	(
	'".$fn."',
	'".$ln."',
	'".$picture."',
	'".$phone."',
	'".$email."',
	'".$gender."',
	'".$date_of_birth."',
	'".$profile."',
	".$reading.",
	".$dancing.",
	".$movies.",
	".$music.",
	'".$token."',
	CURDATE()
	)
	";
	if(mysqli_query($con,$sql)){
		/* Close database connection */
		mysqli_close($con);
		return true;
	}else{
		mysqli_close($con);
		return false;
	}
}
/* Selected option function */
function option_selected($value,$comp){
   if($value==$comp){
        return "selected";
   }else{
        return "";
   }
}
/* Checked input function  */
function is_checked($value,$comp){
   if($value==$comp){
        return "checked";
   }else{
        return "";
   }
}
/* Initialize form data */
$feedback = 0;
$response = "";
$fn = "";
$ln = "";
$phone = "";
$email = "";
$day = "";
$month = "";
$year = "";
$profile = "";
$gender = "";
$reading = 0;
$reading=0; 
$dancing = 0;
$dancing=0; 
$music = 0;
$music=0; 
$movies = 0;
/* Check if form is submitted to retrieve the values */
if(isset($_POST['fn'])){
    $fn = $_POST['fn'];
    $ln = $_POST['ln'];
    $phone = $_POST['phone'];
    $email = $_POST['email'];
    $day = $_POST['day'];
    $month = $_POST['month'];
    $year = $_POST['year'];
    $profile = $_POST['profile'];
    $gender = "";
	$picture = $_FILES['picture']['name'];
    if(isset($_POST['gender'])){
        $gender = $_POST['gender'];
    }
    $reading = 0;
    if(isset($_POST['reading'])){
	$reading=1; 
    }
    $dancing = 0;
    if(isset($_POST['dancing'])){
	$dancing=1; 
    }
    $music = 0;
    if(isset($_POST['music'])){
	$music=1; 
    }
    $movies = 0;
    if(isset($_POST['movies'])){
	$movies=1; 
    }
	if(empty($fn)){
		$response = "Please enter your first name";
    }else if(empty($ln)){
		$response = "Please enter last name";
    }else if(empty($phone)){
		$response = "Please enter phone number";
    }else if(empty($email)){
		$response = "Please enter email address";
    }else if(empty($gender)){
		$response = "Please select gender";
    }else if((empty($day))||(empty($month))||(empty($year))||(!checkdate($month,$day,$year))){
		$response = "Please check date of birth";
    }else if(empty($profile)){
		$response = "Please enter profile";
    }else if(empty($picture)){
		$response = "Please upload a picture";
	}else if(!validate_mage($picture)){
		$response = "Please only jpg, jpeg, png or gif files allowed";
	}else{
		/* Get the extension */
		$ext = get_extension($picture);
		/* Rename file */
		$image = generate_token().".".$ext;
		$path = "pictures/".$image;
		/* Note - We are saving the pictures in the pictures folder that's why you created that folder */
		/* Savel Image */
		if(copy($_FILES['picture']['tmp_name'], $path)){
			/* Since date is inserted in the year-month-day format, create the date_of_birth string */
			$date_of_birth = $year."-".$month."-".$day;
			/* Call the database function to insert the information. Check if insertion is successful to give successful feedback */
			if(add_person($fn,$ln,$phone,$email,$date_of_birth,$profile,$gender,$image,$reading,$dancing,$movies,$music)){
				$response = "Information successfully recorded";
				$feedback = 1;
				$fn = "";
				$ln = "";
				$phone = "";
				$email = "";
				$day = "";
				$month = "";
				$year = "";
				$profile = "";
				$gender = "";
				$reading = 0;
				$reading=0; 
				$dancing = 0;
				$dancing=0; 
				$music = 0;
				$music=0; 
				$movies = 0;
			}else{
				$response = "Failed adding person. Please try again later.";
			}
		}else{
			$response = "Image upload failed. Please try again later";
		}
    }
}
?>
<html>
	<head>
		<style>
			input:focus,button:focus,TextArea:focus,select:focus{
				outline:none;
			}
			input[type="text"],input[type="email"],input[type="password"]{
				display: block;
				font-family: 'Open Sans Light', 'Open Sans', Arial, Helvetica, sans-serif;
				font-weight: 200;
				border: 1px solid #BEBEBE;
				color: #4A4A4A;
				font-size: 14px;
				padding: 5px;
				margin-top:5px;
			}
			input[type="text"]::placeholder,input[type="email"]::placeholder, input[type="password"]::placeholder{
				color: #6c757d;
				opacity: 1;
			}
			select{
				color: #4A4A4A;
				font-size: 14px;
				padding: 5px;
			}
			#animation{
				display:none;
				width:200px;
			}
			.spinner {
			  height: 10px;
			  width: 10px;
			  animation: rotate 0.8s infinite linear;
			  border: 8px solid #7CC1E6;
			  border-right-color: transparent;
			  border-radius: 50%;
			  margin-left:auto;
			  margin-right:auto;
			}

			@keyframes rotate {
			  0%    { transform: rotate(0deg); }
			  100%  { transform: rotate(360deg); }
			}
			.information p, .success p, .warning p,.validation p,.error p{
				margin-top: 5px;
			}
			.error {
				color: #D8000C;
				background-color: #FFBABA;
				background-image: url('images/error.png');
			}
			.information {
				color: #00529B;
				background-color: #BDE5F8;
				background-image: url('images/info.png');
			}
			.success {
				color: #4F8A10;
				background-color: #88ffd1;
				background-image:url('images/success.png');
			}
			.warning {
				color: #9F6000;
				background-color: #FEEFB3;
				background-image: url('images/warning.png');
			}
			.error,.success,.warning,.information {
				margin: 10px 0px;
				padding: 9px 10px 10px 50px;
				background-repeat: no-repeat;
				background-position: 10px center;
			}
			.feedback{
				width:400px;
			}
		</style>
	</head>
	<body>
		<h4>ADD PERSON</h4>
		<form method="POST" action="" id="AddPersonForm" enctype="multipart/form-data">
			<p><b>First Name</b>
			<br><input type="text" name="fn" value="<?php echo $fn;?>"/>
			</p>
			<p><b>Last Name</b>
			<br><input type="text" name="ln" value="<?php echo $ln;?>"/>
			</p>
			<p><b>Phone</b>
			<br><input type="phone" name="phone" value="<?php echo $phone;?>"/>
			</p>
			<p><b>Email</b>
			<br><input type="email" name="email" value="<?php echo $email;?>"/>
			</p>
			<p><b>Gender</b>
			<br><input type="radio" name="gender" value="Male" <?php echo is_checked("Male",$gender);?>> Male <input type="radio" name="gender" value="Female" <?php echo is_checked("Female",$gender);?>> Female 
			</p>
			<p><b>Date of Birth</b>
			<br><select name="day">
					<option value="">Day:</option>
					<?php
					for($i=1;$i<=31;$i++){
						if($i<10){
							$d = "0".$i;
						}else{
							$d = $i;
						}
						?>
						<option value="<?php echo $d;?>" <?php echo option_selected($d,$day);?>><?php echo $d;?></option>
						<?php
					}
					?>
				</select>
				<select name="month">
					<option value="">Month:</option>
					<option value="01" <?php echo option_selected("01",$month);?>>January</option>
					<option value="02" <?php echo option_selected("02",$month);?>>February</option>
					<option value="03" <?php echo option_selected("03",$month);?>>March</option>
					<option value="04" <?php echo option_selected("04",$month);?>>April</option>
					<option value="05" <?php echo option_selected("05",$month);?>>May</option>
					<option value="06" <?php echo option_selected("06",$month);?>>June</option>
					<option value="07" <?php echo option_selected("07",$month);?>>July</option>
					<option value="08" <?php echo option_selected("08",$month);?>>August</option>
					<option value="09" <?php echo option_selected("09",$month);?>>September</option>
					<option value="10" <?php echo option_selected("10",$month);?>>October</option>
					<option value="11" <?php echo option_selected("11",$month);?>>November</option>
					<option value="12" <?php echo option_selected("12",$month);?>>December</option>
				</select>
				<select name="year">
					<option value="">Year:</option>
					<?php
					$start = date('Y');
					$end = $start-150;
					for($i=$start;$i>=$end;$i--){
						?>
						<option value="<?php echo $i;?>"   <?php echo option_selected($i,$year);?>><?php echo $i;?></option>
						<?php
					}
					?>
				</select>
			</p>
			<p><b>Profile</b>
			<br><TextArea name="profile" rows="5"><?php echo $profile;?></TextArea>
			</p>
			<p><b>Hobbies</b>
			<br><input type="checkbox" name="reading" <?php echo is_checked(1,$reading);?>> Reading
			<br><input type="checkbox" name="movies" <?php echo is_checked(1,$movies);?>> Watching Movies
			<br><input type="checkbox" name="dancing" <?php echo is_checked(1,$dancing);?>> Dancing
			<br><input type="checkbox" name="music" <?php echo is_checked(1,$music);?>> Listening To Music
			</p>
			<p>Picture
			<br><input type="file" name="picture" accept="image/*"/>
			</p>
			<p><input type="submit" value="Add" /></p>
		</form>
		<?php
		if(!empty($response)){
			if($feedback==1){
			?>
				<div class="feedback"><div class="success"><?php echo $response;?></div></div>
			<?php
			}else{
			?>
				<div class="feedback"><div class="error"><?php echo $response;?></div></div>
			<?php	
			}
		}
		?>
	</body>
</html>