<?php
function checkbox_checked($value,$comp){
	if($value==$comp){
		/* Return the html code for correct */
		return "&#10004;";
	}else{
		return "";
	}
}
function persons(){
	/* Connect to the database */
	$con = mysqli_connect("localhost","root","","test");
	/* Create an array to store the fetched rows */
	$persons = array();
	/* SQL Query */
	$sql = "select * from persons order by id desc";
	$query = mysqli_query($con,$sql);
	while($row=mysqli_fetch_array($query)){
		array_push($persons,$row);
	}
	/* Close the database */
	mysqli_close($con);
	/* Return the persons array */
	return $persons;
}
/* Get the persons from the database by calling the persons function */
$persons = persons();
if(count($persons)>0){
?>
	<table width="100%" border="1">
		<tr>
			<th>First Name</th>
			<th>Last Name</th>
			<th>Picture</th>
			<th>Phone</th>
			<th>Email</th>
			<th>Gender</th>
			<th>Date Of Birth</th>
			<th>Profile</th>
			<th>Reading</th>
			<th>Movies</th>
			<th>Dancing</th>
			<th>Music</th>
		</tr>
		<?php
		foreach($persons as $person){
		?>
			<tr>
				<td><?php echo $person['firstname'];?></td>
				<td><?php echo $person['lastname'];?></td>
				<td><img src="pictures/<?php echo $person['picture'];?>" width="100" /></td>
				<td><?php echo $person['phone'];?></td>
				<td><?php echo $person['email'];?></td>
				<td><?php echo $person['gender'];?></td>
				<td><?php echo $person['date_of_birth'];?></td>
				<td><?php echo $person['profile'];?></td>
				<td><?php echo checkbox_checked(1,$person['reading']);?></td>
				<td><?php echo checkbox_checked(1,$person['movies']);?></td>
				<td><?php echo checkbox_checked(1,$person['dancing']);?></td>
				<td><?php echo checkbox_checked(1,$person['music']);?></td>
			</tr>
		<?php
		}
		?>
	</table>	
<?php	
}else{
?>
	<p>No person on record</p>
<?php
}
?>